Recent

Author Topic: Rebuilding 2.2.0 with FPC 3.2.2 on RPi  (Read 989 times)

MarkMLl

  • Hero Member
  • *****
  • Posts: 5151
Rebuilding 2.2.0 with FPC 3.2.2 on RPi
« on: February 18, 2022, 08:03:29 pm »
I anticipated needing to debug some stuff on an RPi that couldn't be done on a PC, since it needed simultaneous I2C and GPIO access.

Since I've recently upgraded my main development PC to (locally built) FPC 3.2.2 and Lazarus 2.2.0 I thought it appropriate to do the same on the RPi in case there were any issues with .lpi format etc. This is something I've done plenty of times before on various platforms.

Curiously, I was able to build both "all" and "bigide" for gtk2 and "all" for qt5, but "bigide" for qt5 failed in unpredictable ways.

It turns out that the RPi swapfile was set to 100Mb, editing /etc/dphys-swapfile to 2048Mb and rebooting fixed the problem.

I don't know whether Lazarus+qt5 suddenly requires more resources, whether the RPi upgrade I did a few weeks ago is defaulting to a smaller swapfile, or whether I last built FPC+Lazarus on that platform using Debian with a much larger swap partition. But it certainly looks as though swap <1024Mb won't work: I've normally assumed 512Mb as a safe minimum even on systems with vastly less RAM.

Of course, during the time it took me to sort that out I also fixed and tested the kernel modules that support a CH341A card, so was able to do the work on a PC after all.

MarkMLl
MT+86 & Turbo Pascal v1 on CCP/M-86, multitasking with LAN & graphics in 128Kb.
Pet hate: people who boast about the size and sophistication of their computer.
GitHub repositories: https://github.com/MarkMLl?tab=repositories

Thaddy

  • Hero Member
  • *****
  • Posts: 11911
Re: Rebuilding 2.2.0 with FPC 3.2.2 on RPi
« Reply #1 on: February 18, 2022, 08:51:36 pm »
qt5 is a known issue, make clean all should work ( at least here) bigide can be a problem only on older or smaller pi's.
Black themes should be banned.

MarkMLl

  • Hero Member
  • *****
  • Posts: 5151
Re: Rebuilding 2.2.0 with FPC 3.2.2 on RPi
« Reply #2 on: February 18, 2022, 09:47:22 pm »
Make clean all appeared OK. But I suspect that things have got worse with the current releases (i.e. either of Lazarus/FPC or RPi's variant of Bullsye) since I /think/ I built 2.0.12+3.2.0 myself on the previous RPi OS a few months ago and that definitely included qt5/bigide.

At first I thought it was because I was controlling the build over WiFi and that it was being glitched by the storm that was raging outside. It was as rough as I've ever seen it today...

[Later] I've found the RPi backup from "Buster" and it was running with a 100Mb swapfile, but the only Lazarus/FPC on it was 1.6.4+3.0.2. The implication there is that I'd built 2.0.12+3.2.0 on the current RPi release, and that 2.2.0+3.2.2 is more demanding: 1Gb RAM + ~1Gb swap.

MarkMLl
« Last Edit: February 18, 2022, 10:00:13 pm by MarkMLl »
MT+86 & Turbo Pascal v1 on CCP/M-86, multitasking with LAN & graphics in 128Kb.
Pet hate: people who boast about the size and sophistication of their computer.
GitHub repositories: https://github.com/MarkMLl?tab=repositories

 

TinyPortal © 2005-2018